{*******************************************}
{                                           }
{            FastReport v2.2                }
{          Objet complmentaire             }
{       Code Barre                          }
{                                           }
{ FastReport :(c) 1998-99 by Tzyganenko A.  }
{ Fr_TeeChart: Guilbaud Olivier             }
{             golivier@worldnet.fr       }
{ Merci de transmettre vos commantaires     }
{                                           }
{Ce composant est un FREEWARE               }
{*******************************************}
{Histo :                                    }
{ 10/05/1999 : Cration                     }
{
{ A Faire :                                 }
{  * Utiliser les variables pour initialiser}
{    le graph.                              }


unit FR_TeeCh;

interface
Uses Windows, Messages, SysUtils, Classes, Graphics, Controls,Forms,
     Fr_Class,FR_Pars, FR_DSet, FR_DBSet, FR_Utils,
     TeeProcs, TeEngine, Chart, DBChart, ExtCtrls;


type
  TfrTeeChartObject = class(TComponent)  // composant
                      end;

  TfrTeeChartView = class(TfrPictureView)
  Private
    FCompo : TComponent;
    FTeeCh : TDbChart;

  public
    constructor Create; override;
    Destructor Destroy; override;
    procedure Assign(From:TfrView); override;
    procedure LoadFromStream(Stream:TStream); override;
    procedure SaveToStream(Stream:TStream); override;
    procedure Draw(Canvas:TCanvas); override;
  end;

  // Editeur de proprits
  TTeeChartForm = class(TfrObjEditorForm)
    Image1: TImage;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure ShowEditor(t:TfrView); override;
  end;


Procedure Register;

implementation

{$R *.DFM}
{.$R *.DCR}

Uses DbEditCh,Db;

Var TeeChartForm : TTeeChartForm;

Constructor TfrTeeChartView.Create;
Begin
  Inherited Create;

  FCompo:=TComponent.Create(NIL);
  // Init
  FTeeCh:=TDbChart.Create(FCompo);//TeeChartForm);
  FTeeCh.Color:=clNone;
  FTeeCh.BevelOuter:=bvNone;
End;

Destructor TfrTeeChartView.Destroy;
Begin
  FTeeCh.free;
  FCompo.Free;
  Inherited Destroy;
end;

procedure TFrTeeChartView.Assign(From:TfrView);
Begin
 inherited Assign(From);
 FTeeCh:=(From as TfrTeeChartView).FTeeCh;
end;

procedure TFrTeeChartView.LoadFromStream(Stream:TStream);
Begin
  Inherited LoadFromStream(Stream);

  FteeCh.Free;
  FTeeCh:=TDbChart.Create(FCompo);
  FTeeCh.Color:=clNone;
  FTeeCh.BevelOuter:=bvNone;
  Stream.ReadComponent(FTeeCh);
end;

procedure TFrTeeChartView.SaveToStream(Stream:TStream);
Begin
  Inherited SaveToStream(Stream);
  Stream.WriteComponent(FTeeCh);
end;

procedure TFrTeeChartView.Draw(Canvas:TCanvas);
Begin
  BeginDraw(Canvas);
  CalcGaps;
  FTeeCh.Color:=FillColor;
  FTeeCh.DrawToMetaCanvas(Canvas,DRect);
  ShowFrame;
end;

//***********************************************//
procedure TTeeChartForm.ShowEditor(t:TfrView);
Begin
  with t as TfrTeeChartView do
  begin
     EditDbChart(Self,FTeeCh); // Lance l'diteur de prop.
  end;
end;

Procedure Register;
begin
RegisterComponents('FastReport',[TfrTeeChartObject]);
end;

initialization
  TeeChartForm := TTeeChartForm.Create(nil);
  If GetClass('TDbChart')=NIL then RegisterClass(TDBChart);
  frRegisterObject(TfrTeeChartView,TeeChartForm.Image1.Picture.Bitmap,
    frLoadStr('sTeeChartHint'),TeeChartForm);

finalization
  TeeChartForm.Free;
end.
